package consume

import (
	"applet/app/cfg"
	"applet/app/db"
	md4 "applet/app/md"
	utils2 "applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/EggPlanet/egg_models.git/src/implement"
	"code.fnuoos.com/EggPlanet/egg_models.git/src/model"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git/enum"
	md3 "code.fnuoos.com/EggPlanet/egg_system_rules.git/md"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git/rule"
	md2 "code.fnuoos.com/EggPlanet/egg_system_rules.git/rule/egg_energy/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
	"strconv"
	"time"
)

func EggEnergyRecruitNewUserRewardConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>EggEnergyRecruitNewUserRewardConsume>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	egg_system_rules.Init(cfg.RedisAddr)
	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			err = handleEggEnergyRecruitNewUserRewardConsume(res.Body)
			if err != nil {
				fmt.Println("EggEnergyRecruitNewUserRewardConsume_ERR:::::", err.Error())
				utils2.FilePutContents("EggEnergyRecruitNewUserRewardConsume_ERR", utils2.SerializeStr(map[string]interface{}{
					"body": res.Body,
					"err":  err.Error(),
				}))
				_ = res.Reject(true) //TODO::拒绝
			} else {
				err = res.Ack(true)
				fmt.Println("err ::: ", err)
			}
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleEggEnergyRecruitNewUserRewardConsume(msgData []byte) error {
	//1、解析mq中queue的数据结构体
	var msg *md4.EggEnergyRecruitNewUserRewardMq
	err := json.Unmarshal(msgData, &msg)
	if err != nil {
		return err
	}
	engine := db.Db

	//2、给到直推奖励
	eggEnergyRecruitNewUserRewardDb := implement.NewEggEnergyRecruitNewUserRewardDb(engine)
	_, exist, _ := eggEnergyRecruitNewUserRewardDb.EggEnergyRecruitNewUserRewardGet(msg.Uid)
	if !exist { //TODO::判断是否签到过
		eggEnergyBasicSettingDb := implement.NewEggEnergyBasicSettingDb(db.Db)
		eggEnergyBasicSetting, err1 := eggEnergyBasicSettingDb.EggEnergyBasicSettingGetOneByParams(map[string]interface{}{
			"key":   "is_open",
			"value": 1,
		})
		if err1 != nil {
			return err1
		}
		if eggEnergyBasicSetting != nil {
			userDb := implement.NewUserDb(db.Db)
			user, err1 := userDb.GetUser(msg.Uid)
			if err1 != nil {
				return err1
			}
			if user != nil {
				userDeleteInfoDb := implement.NewUserDeleteInfoDb(db.Db)
				userDelete := userDeleteInfoDb.GetUserDeleteInfo(user.Phone)
				fmt.Println("userDelete>>>>>>>>>>>>>>>", userDelete)
				if userDelete == nil {
					var newUserRewardRules *md2.NewUserRewardRules
					err2 := json.Unmarshal([]byte(eggEnergyBasicSetting.NewUserIncentiveRules), &newUserRewardRules)
					if err2 != nil {
						fmt.Println("handleEggEnergyRecruitNewUserRewardConsume___ERR>>>>", err2.Error())
					}
					rewardValue := newUserRewardRules.InviteUserRewardValue
					_, err2 = eggEnergyRecruitNewUserRewardDb.EggEnergyRecruitNewUserRewardInsert(&model.EggEnergyRecruitNewUserReward{
						Uid:          user.Id,
						RecommendUid: user.ParentUid,
						Value:        strconv.Itoa(rewardValue),
						CreateAt:     time.Now().Format("2006-01-02 15:04:05"),
						UpdateAt:     time.Now().Format("2006-01-02 15:04:05"),
					})
					if err2 != nil {
						return err2
					}

					session := db.Db.NewSession()
					err2 = rule.DealUserVirtualCoin(session, md3.DealUserVirtualCoinReq{
						Kind:         "add",
						Title:        enum.UserVirtualAmountFlowTransferType.String(enum.EggEnergyRecruitNewUsersReward),
						TransferType: int(enum.EggEnergyRecruitNewUsersReward),
						CoinId:       eggEnergyBasicSetting.PersonEggPointsCoinId,
						Uid:          user.ParentUid,
						Amount:       float64(rewardValue),
					})
					if err2 != nil {
						return err2
					}
					session.Commit()
				}
			}
		}
	}

	return nil
}
